let signed = false, token = "", user_id = "";

chrome.storage.local.get(['token', 'user_id', 'isScrapping'], function(result) {
    token = result.token || "";
    user_id = result.user_id || "";
    let isScrapping = result.isScrapping || "false";
    signed = user_id !== "" && token !== "";
    chrome.action.setBadgeText({text: isScrapping === "true" ? " ON " : " OFF "});
    if (signed) {
        chrome.action.setPopup({popup: "popup-signed.html"});
    }
});

let addLeadApi = 'https://vsretriever.com/api/add-lead';
let logoutApi = 'https://vsretriever.com/api/logout';

let latestLead = {
    leadName: "-",
    leadStatus: "-"
}

// set interval to check if last lead was recieved 30 minutes ago


chrome.runtime.onMessage.addListener((request, sender, sendResponse) => {
    switch (request.message) {
        case "login":
            chrome.tabs.create({url: "https://vsretriever.com/login"});
            break;
        case "logout":
            chrome.storage.local.get('token').then((localResponse) => {
                token = localResponse.token;
                fetch(logoutApi, {
                    method: 'POST',
                    headers: {
                        'Content-Type': 'application/json',
                    },
                    body: JSON.stringify({ user_id, token })
                }).then(response => response.json()).then(data => {
                    if (data == 1) {
                        chrome.storage.local.remove(["user_id", "token"]);
                        chrome.storage.local.set({isScrapping: "false"});
                        signed = false;
                        chrome.action.setPopup({popup: "popup-unsigned.html"});
                        chrome.action.setBadgeText({text: " OFF "});
                        chrome.tabs.query({
                            currentWindow: true,
                            active: true
                        }, function (tabs) {
                            chrome.tabs.remove(tabs[0].id);
                        });
                    }
                    console.log('Success:', data);
                }).catch((error) => {
                    console.error('Error:', error);
                });
            });
            sendResponse({message: "success"});
            return true; // indicates async response
        case "newLead":
            let requesData = request.data;
            // Get token
            console.log('Token:', token);
            chrome.storage.local.get('token').then((localResponse) => {
                console.log(localResponse);
                token = localResponse.token;
                fetch(addLeadApi, {
                    method: 'POST',
                    headers: {
                        'Content-Type': 'application/json',
                    },
                    body: JSON.stringify({
                        user_id, token, data: requesData
                    }),
                }).then(response => response.json()).then(data => {
                    chrome.storage.local.set({token: data.token});
                    //Lead Added Successfully with status of New!
                    //Lead Already Exists!
                    //Lead Added Successfully with status of Updated!
                    if(data.message === "Lead Added Successfully with status of New!"){
                        latestLead.leadName = requesData.fname + " " + requesData.lname;
                        latestLead.leadStatus = "New";
                    }else if(data.message === "Lead Added Successfully with status of Updated!"){
                        latestLead.leadName = requesData.fname + " " + requesData.lname;
                        latestLead.leadStatus = "Updated";
                    }else if(data.message === "Lead Already Exists!"){
                        latestLead.leadName = requesData.fname + " " + requesData.lname;
                        latestLead.leadStatus = "Already Exists";
                    }else if(data.message === "Subscription Expired!"){
                        latestLead.leadName = "Subscription Expired!";
                        latestLead.leadStatus = "Subscription Expired!";
                    }
                    
                    chrome.storage.local.set({latestLead});
                    
                    console.log('Success:', data);
                    
                }).catch((error) => {
                    console.error('Error:', error);
                });
            });
            sendResponse({message: "success"});
            return true; // indicates async response
        case "isScrapping":
            chrome.storage.local.get('isScrapping', function(result) {
                sendResponse({isScrapping: result.isScrapping === "true"});
            });
            return true; // indicates async response
        case "changeScrappingStatus":
            chrome.storage.local.set({isScrapping: request.isScrapping ? "true" : "false"});
            chrome.action.setBadgeText({text: request.isScrapping ? " ON " : " OFF "});
            sendResponse({message: "success"});
            return true; // indicates async response
        case "isSigned":
            sendResponse({isSigned: signed});
            return true; // indicates async response
        case "logged":
            chrome.tabs.query({
                currentWindow: true,
                active: true
            }, function (tabs) {
                chrome.tabs.remove(tabs[0].id);
            });
            signed = true;
            token = request.token;
            user_id = request.user_id;
            chrome.storage.local.set({
                user_id: request.user_id,
                token: request.token
            });
            chrome.tabs.create({url: "https://vanillasoft.net/web/default.asp"});
            chrome.action.setPopup({popup: "popup-signed.html"});
            sendResponse({message: "success"});
            return true; // indicates async response
        case "getLatestLead":
            sendResponse({leadName: latestLead.leadName, leadStatus: latestLead.leadStatus});
            return true; // indicates async response
    }
});
