// Listen for messages from background.js using chrome.tabs.sendMessage
chrome.runtime.onMessage.addListener((request, sender, sendResponse) => {
    if(request.type == "reload"){
        location.reload();
        sendResponse({message: "Page reloaded!"});
        return true;
    }
});

window.addEventListener('message', function(event) {
    // Make sure the message is from your web page
    if (event.data.action && (event.data.action == "logged")) {
        //console.log("Token :", event.data.token);
        chrome.runtime.sendMessage({message: "logged", token: event.data.token, user_id: event.data.user_id}, function(response) {
            //console.log(response);
        });
    }
});
let leadTime = new Date();
setInterval(() => {
    let currentTime = new Date();
    let diff = currentTime - leadTime;
    console.log(diff);
    if (diff > 1800000) {
        // chrome send message logout
        console.log("Loging out idle user");
        chrome.runtime.sendMessage({message: "logout"}, (response) => {
            console.log(response);
        });
    }
}, 60000);

document.onreadystatechange = () => {
    if(document.readyState == "complete"){
        //console.log("Content.js loaded");
        chrome.runtime.sendMessage({message: "isSigned"}, (response) => {
            if(response.isSigned){
                chrome.runtime.sendMessage({message: "isScrapping"}, (response) => {
                    //console.log("Scrapping");
                    var iframeChecker = setInterval(() => {
                        try{
                            //console.log("Checking for iframe")
                            const iframe = document.getElementById('bodyIframe');
                            const docs = iframe.contentDocument;
                
                            if(docs.readyState == "complete"){
                                clearInterval(iframeChecker);
                                //console.log("Iframe is ready")
                                let currentData = {};
                                let oldData = {};
                
                                const getData = () => {
                                    let FirstName = docs.querySelector("#FirstName")?.value;
                                    let MiddleName = docs.querySelector("#MiddleName")?.value;
                                    let LastName = docs.querySelector("#LastName")?.value;
                                    let Suffix = docs.querySelector("#Suffix")?.value;
                                    let Title = docs.querySelector("#Title")?.value;
                                    let Company = docs.querySelector("#Company")?.value;
                                    let DNC = docs.querySelector("#callbtn_primary_phone .callBlocked")?.innerText == undefined ? "No" : "Yes";
                                    let Address = docs.querySelector("#Address1")?.value;
                                    let City = docs.querySelector("#City")?.value;
                                    let State = docs.querySelector("#State")?.value;
                                    let ZipCode = docs.querySelector("#ZipCode")?.value;
                                    let Country = docs.querySelector("#Country")?.value;
                                    let Email = docs.querySelector("#Email")?.value;
                                    let PhoneNumber = docs.querySelector("#clientPanelPhoneFetch input")?.value;
                                    let Status = docs.querySelector("#ddlLeadStatus");
                                    Status = Status?.options[Status.selectedIndex]?.text;
                                    let ContactTime = docs.querySelector("#tr_contact_time .time")?.innerText + " " + docs.querySelector("#tr_contact_time .zone")?.innerText;
                                    let ContactId = docs.querySelector("#tr_contact_id #tplStatus_contact_id")?.innerText;
                                    let LeadSource = docs.querySelector("#tr_lead_source #tplStatus_lead_source")?.innerText;
                                    let ContactOwner = docs.querySelector("#tr_contact_owner #tplStatus_contact_owner")?.innerText;
                                    let ContactTeam = docs.querySelector("#tr_contact_owner_team #tplStatus_contact_owner_team")?.innerText;
                                    let AddedOn = docs.querySelector("#tr_contact_added_on #tplStatus_contact_added_on")?.innerText;
                                    
                                    let data = {
                                        added_on: AddedOn,
                                        lead_source: LeadSource,
                                        fname: FirstName,
                                        lname: LastName,
                                        address: Address,
                                        city: City,
                                        state: State,
                                        zip_code: ZipCode,
                                        email: Email,
                                        phone_number: PhoneNumber,
                                        do_not_call: DNC,
                                    };
                
                                    return data;
                                }
                                
                                var newLeadChecker = setInterval(() => {
                                    chrome.runtime.sendMessage({message: "isSigned"}, (response) => {
                                        //console.log("Checking if signed");
                                        if(response.isSigned){
                                            //console.log("Signed in");
                                            chrome.runtime.sendMessage({message: "isScrapping"}, (response) => {
                                                //console.log("Checking if scrapping");
                                                if(response.isScrapping){
                                                    //console.log("Scrapping is on");
                                                    currentData = getData();
                                                    //console.log(currentData, oldData);
                                                    if(JSON.stringify(currentData) != JSON.stringify(oldData)){
                                                        //console.log("Data changed");
                                                        oldData = currentData;
                                                        //console.log("Checking if signed")
                                                        chrome.runtime.sendMessage({message: "isScrapping"}, (response) => {
                                                            if(response.isScrapping){
                                                                chrome.runtime.sendMessage({message: "newLead", data: currentData}, (response) => {
                                                                    leadTime = new Date();
                                                                    //console.log(response);
                                                                });
                                                            }else{
                                                                //console.log("Scrapping is off");
                                                            }
                                                        });
                                                            
                                                    }else{
                                                        //console.log("Data not changed");
                                                    }
                                                }else{
                                                    //console.log("Scrapping is off");
                                                }
                                            });
                                        }else{
                                            //console.log("Not signed in");
                                            clearInterval(newLeadChecker);
                                        }
                                    });
                                }, 500);
                            }else{
                                //console.log("Iframe is not ready")
                            }
                        }catch{
                            //console.log("Iframe is not ready");
                        }
                    }, 1000);
                });
            }
        });
    }else{
        //console.log("Document is not ready")
    }
};