document.addEventListener('DOMContentLoaded', function () {
    var scrappingBtn = document.querySelector('#isScrapping');

    if(scrappingBtn){
        chrome.runtime.sendMessage({message: "isScrapping"}, (response) => {
            scrappingBtn.checked = response.isScrapping;
            if(response.isScrapping){
                document.querySelector('#status').innerText = "Enabled";
                document.querySelector('#status').style.color = "#407bbe";
            }else{
                document.querySelector('#status').innerText = "Disabled";
                document.querySelector('#status').style.color = "#be8740";
            }
        });
    }

    scrappingBtn?.addEventListener('change', function () {
        chrome.runtime.sendMessage({message: "changeScrappingStatus", isScrapping: scrappingBtn.checked});
        if(scrappingBtn.checked){
            document.querySelector('#status').innerText = "Enabled";
            document.querySelector('#status').style.color = "#407bbe";
        }else{
            document.querySelector('#status').innerText = "Disabled";
            document.querySelector('#status').style.color = "#be8740";
        }
    });

    let btn = document.querySelector('.signInOut');

    btn.addEventListener('click', function () {
        chrome.runtime.sendMessage({ message: btn.dataset["action"] }, async function(response) {
            if(response.message === "success" && response.type === "login"){
                //console.log("Logged in");
            }else if(response.message === "success" && response.type === "logout"){
                //console.log("Logged out");
            }
                
            window.close();
        });
    });
});

chrome.runtime.sendMessage({ message: "getLatestLead" }, async function(response) {
    try{
        document.querySelector('.leadfname').innerText = response.leadName;
        document.querySelector('.leadstatus').innerText = response.leadStatus;
    }catch{

    }
});

chrome.storage.onChanged.addListener(function(changes, namespace) {
    // Check if latestLead is changed
    if(changes.latestLead){
        try{
            document.querySelector('.leadfname').innerText = changes.latestLead.newValue.leadName;
            document.querySelector('.leadstatus').innerText = changes.latestLead.newValue.leadStatus;
        }catch{
            
        }
    }
});